; Script generated by the HM NIS Edit Script Wizard.
SetCompressor bzip2
; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "OpenMAIA"
!define PRODUCT_VERSION "0.5.1"
!define PRODUCT_PUBLISHER "The OpenMAIA Group"
!define PRODUCT_WEB_SITE "http://www.maiaproject.org"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\maia.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "..\..\..\COPYING"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "Italian"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "OpenMAIA_05_1.exe"
InstallDir "$PROGRAMFILES\OpenMAIA"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show



Section "SezionePrincipale" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\..\..\COPYING"
  File "..\..\..\AUTHORS"
  SetOutPath "$INSTDIR\bin"
  File "..\..\..\src\maia\maia.exe"
  File "..\..\..\src\openmaia\openmaia.exe"
  File "..\lib\*.dll"
  File "..\bin\*.exe"
  File "..\bin\*.manifest"
  File "..\..\..\src\maiaconfig\maiaconfig.exe"
  File "..\..\..\src\maiasms\maiasms.exe"
  SetOutPath "$INSTDIR\share"
  File "..\..\..\data\openmaia.conf"
  SetOutPath "$INSTDIR\share\profiles\default\openmaia"
  File "..\..\..\data\default\openmaia\*.*"
  SetOutPath "$INSTDIR\share\profiles\default\maia\etc"
  File "..\..\..\data\default\maia\etc\maia.conf"
  SetOutPath "$INSTDIR\share\profiles\default\maia\keyboard"
  File "..\..\..\data\default\maia\keyboard\*.xml"
  SetOutPath "$INSTDIR\share\profiles\default\maia\keyboard\images"
  File "..\..\..\data\default\maia\keyboard\images\*.jpg"
  SetOutPath "$INSTDIR\share\profiles\default\maia\keyboard\sounds"
  File "..\..\..\data\default\maia\keyboard\sounds\*.wav"
  SetOutPath "$INSTDIR\share\resource\common"
  File "..\..\..\data\resource\common\*.*"
  SetOutPath "$INSTDIR\share\resource\maiaconfig"
  File "..\..\..\data\resource\maiaconfig\*.*"
  SetOutPath "$INSTDIR\share\resource\openmaia"
  File "..\..\..\data\resource\openmaia\*.*"
  SetOutPath "$INSTDIR\share\icons"
  File "..\..\..\data\icons\*.*"
  CreateDirectory "$SMPROGRAMS\OpenMAIA"
#  CreateDirectory "$SMPROGRAMS\OpenMAIA\Componenti"
  CreateShortCut "$SMPROGRAMS\OpenMAIA\OpenMAIA.lnk" "$INSTDIR\bin\openmaia.exe" "" "$INSTDIR\share\icons\openmaia.ico"
#  CreateShortCut "$SMPROGRAMS\OpenMAIA\Componenti\MailSMS.lnk" "$INSTDIR\bin\maiasms.exe" "" "$INSTDIR\share\icons\openmaia.ico"
  CreateShortCut "$DESKTOP\OpenMAIA.lnk" "$INSTDIR\bin\openmaia.exe" "" "$INSTDIR\share\icons\openmaia.ico"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\OpenMAIA\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\OpenMAIA\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\bin\maia.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\bin\maia.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name)  stato completamente rimosso dal tuo computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Sei sicuro di voler completamente rimuovere $(^Name) e tutti i suoi componenti?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\share\resource\openmaia\*.*"
  Delete "$INSTDIR\share\resource\maiaconfig\*.*"
  Delete "$INSTDIR\share\resource\common\*.*"
  Delete "$INSTDIR\share\profiles\default\maia\keyboard\sounds\*.*"
  Delete "$INSTDIR\share\profiles\default\maia\keyboard\images\*.*"
  Delete "$INSTDIR\share\profiles\default\maia\keyboard\*.*"
  Delete "$INSTDIR\share\profiles\default\maia\etc\*.*"
  Delete "$INSTDIR\share\profiles\default\openmaia\*.*"
  Delete "$INSTDIR\share\icons\*.*"
  Delete "$INSTDIR\share\*.*"
  Delete "$INSTDIR\bin\*.*"
  Delete "$INSTDIR\*.*"

  Delete "$SMPROGRAMS\OpenMAIA\Uninstall.lnk"
  Delete "$SMPROGRAMS\OpenMAIA\Website.lnk"
  Delete "$DESKTOP\OpenMAIA.lnk"
  Delete "$SMPROGRAMS\OpenMAIA\OpenMAIA.lnk"

  RMDir "$SMPROGRAMS\OpenMAIA"
  RMDir "$INSTDIR\share\resource\openmaia"
  RMDir "$INSTDIR\share\resource\maiaconfig"
  RMDir "$INSTDIR\share\resource\common"
  RMDir "$INSTDIR\share\resource"
  RMDir "$INSTDIR\share\profiles\default\maia\keyboard\sounds"
  RMDir "$INSTDIR\share\profiles\default\maia\keyboard\images"
  RMDir "$INSTDIR\share\profiles\default\maia\keyboard"
  RMDir "$INSTDIR\share\profiles\default\maia\etc"
  RMDir "$INSTDIR\share\profiles\default\maia"
  RMDir "$INSTDIR\share\profiles\default\openmaia"
  RMDir "$INSTDIR\share\profiles\default"
  RMDir "$INSTDIR\share\profiles"
  RMDir "$INSTDIR\share\icons"
  RMDir "$INSTDIR\share"
  RMDir "$INSTDIR\bin"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
