////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#ifndef _omARMA_h_
#define _omARMA_h_

#include <openmaia/commons.h>
#include <iostream>
#include <vector>

/** @ingroup omgen

    This class implements an ARMA (Auto Regressive, Moving Average) filter.

    ( documentation coming ...)
*/


class omARMA
{
 private:
  int order; //order of filter
  std::vector<double> x;
  std::vector<double> y; //ARMA x and y storical value
  std::vector<double> a,b; //ARMA parameters

 public:
  omARMA(int order, std::vector<double> a, std::vector<double> b);
  void Initialize(double initValue);
  double Filter(double value);
};

#endif
