////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#ifndef _omGetKeyDialog_
#define _omGetKeyDialog_

#include <openmaia/commons.h>
#include <iostream>

#include <wx/wx.h>
#include <wx/xrc/xmlres.h>


#include <openmaia/omObject.h>



/** @ingroup omgen

    omGetKeyDialog is virtual keyboard used to present a key choice to the user.

*/

class omGetKeyDialog: public wxDialog, public omObject {
 public:
  omGetKeyDialog( wxString) ;

  int ShowModal();
  wxString GetSelectedKey();
  bool IsKeySelected();

  DECLARE_EVENT_TABLE()

 protected:
  wxString selectedKey;
  bool isKeySelected;

 private:
  void OnEsc(wxCommandEvent &);
  void On1(wxCommandEvent &);
  void On2(wxCommandEvent &);
  void On3(wxCommandEvent &);
  void On4(wxCommandEvent &);
  void On5(wxCommandEvent &);
  void On6(wxCommandEvent &);
  void On7(wxCommandEvent &);
  void On8(wxCommandEvent &);
  void On9(wxCommandEvent &);
  void On0(wxCommandEvent &);
  void OnQuote(wxCommandEvent &);
  void OnIgrave(wxCommandEvent &);
  void OnBs(wxCommandEvent &);
  void OnIns(wxCommandEvent &);
  void OnHome(wxCommandEvent &);
  void OnPgUp(wxCommandEvent &);
  void OnTab(wxCommandEvent &);
  void OnQ(wxCommandEvent &);
  void OnW(wxCommandEvent &);
  void OnE(wxCommandEvent &);
  void OnR(wxCommandEvent &);
  void OnT(wxCommandEvent &);
  void OnY(wxCommandEvent &);
  void OnU(wxCommandEvent &);
  void OnI(wxCommandEvent &);
  void OnO(wxCommandEvent &);
  void OnP(wxCommandEvent &);
  void OnEgrave(wxCommandEvent &);
  void OnPlus(wxCommandEvent &);
  void OnUgrave(wxCommandEvent &);
  void OnCanc(wxCommandEvent &);
  void OnEnd(wxCommandEvent &);
  void OnPgDown(wxCommandEvent &);
  void OnCaps(wxCommandEvent &);
  void OnA(wxCommandEvent &);
  void OnS(wxCommandEvent &);
  void OnD(wxCommandEvent &);
  void OnF(wxCommandEvent &);
  void OnG(wxCommandEvent &);
  void OnH(wxCommandEvent &);
  void OnJ(wxCommandEvent &);
  void OnK(wxCommandEvent &);
  void OnL(wxCommandEvent &);
  void OnOgrave(wxCommandEvent &);
  void OnAgrave(wxCommandEvent &);
  void OnEnter(wxCommandEvent &);
  void OnShift(wxCommandEvent &);
  void OnMinor(wxCommandEvent &);
  void OnZ(wxCommandEvent &);
  void OnX(wxCommandEvent &);
  void OnC(wxCommandEvent &);
  void OnV(wxCommandEvent &);
  void OnB(wxCommandEvent &);
  void OnN(wxCommandEvent &);
  void OnM(wxCommandEvent &);
  void OnComma(wxCommandEvent &);
  void OnDot(wxCommandEvent &);
  void OnUnderscore(wxCommandEvent &);
  void OnShift2(wxCommandEvent &);
  void OnUp(wxCommandEvent &);
  void OnControl(wxCommandEvent &);
  void OnAlt(wxCommandEvent &);
  void OnSpace(wxCommandEvent &);
  void OnAltGr(wxCommandEvent &);
  void OnSx(wxCommandEvent &);
  void OnDown(wxCommandEvent &);
  void OnDx(wxCommandEvent &);

} ;

#endif //_omGetKeyDialog_
