////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifndef _omOptions_
#define _omOptions_

#include <openmaia/commons.h>
#include <openmaia/omObject.h>
#include <openmaia/omXMLParser.h>

#include <wx/wx.h>


/** @ingroup omgen

    This class contains all generic options in a maialike application.
    The class can be extended and a subclass can be used instead of it.

    All generic objects in the api structure use this class to store options.
*/


class omOptions: public omXMLParser{
  
 public:  
  omOptions() ;
  virtual void Init() ;

  bool SetParameter(wxString, wxString);
  wxString GetParameter(wxString);
  wxString GenerateOptionsXMLString();


  /** Name of the host that run the openmaia server */
  wxString hostName ;
  /** openmaia server listen port */
  int port;

} ;


#endif // _omOptions_
