////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifndef _OMSMS_H_
#define _OMSMS_H_

#include <openmaia/commons.h>
#include <wx/wx.h>
#include <wx/dynarray.h>

/** @ingroup omgen

    This class is used to store SMS (Cellular Short Message) infromations.
*/

class omSms
{
 public:
  omSms();
  virtual ~omSms();

  long index;		///< message index
  int unread;		///< message downloaded is unread
  wxString sender;	///< phone number of the message sender
  wxString timestamp;	///< date in italian format dd/mm/yyyy
  wxString body;	///< body of the message
} ;


WX_DEFINE_ARRAY(omSms *, omSmsArray);///<Define omSmsArray Type


#endif //_OMSMS_H_
