////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifndef _omTCPMessage_
#define _omTCPMessage_

#include <openmaia/commons.h>
#include <iostream>
#include <wx/wx.h>

#include <openmaia/config.h>
#include <openmaia/omFunctions.h>


/** @ingroup omgen
    Store TCP/IP message.

    This class is used to store a TCP message received or to send.
    Message fileds are stored in public attributes.
*/
class omTCPMessage
{
 public:
  wxString fromAgent;  ///< FROM_AGENT: field
  wxString fromService;   ///< FROM_SERVICE: field
  wxString fromHost;   ///< FROM_IP: field
  wxString toAgent;  ///< TO_AGENT: field
  wxString toService;  ///< TO_SERVICE: field
  wxString toHost;   ///< TO_IP: field
  wxString command;   ///< Command Code field.
  wxArrayString parameters; ///< Parameters.

  // --- methods
  omTCPMessage();
  wxString GetCommand();
  wxString GetParameter(int);
  int GetParCount();
  wxString GetFormattedMessage();

  void AddParameter(wxString) ;
};

#endif
