////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifndef _omUIGrantFocus2User_
#define _omUIGrantFocus2User_

#include <openmaia/commons.h>
#include <wx/wx.h>

#include <openmaia/omObject.h>
#include <openmaia/omUIKeyboard.h>



/** @ingroup omui
    
    This class store the handler of the window not belonged to maia that 
    had the keyboard focus
*/
class omUIGrantFocus2User: public omObject, public wxTimer
{
 private:
  void *lastFocusedWindow ;
  int tickTime ;
  void *sdData ;   // data stored for system dependent methods
  void Notify() ;   // notify method of the timer
  void SDConstructor() ;
  void SDCheckFocusedWindow() ;
  void SDSetLastFocusedWindow() ;
 public:
  omUIGrantFocus2User(int) ;
  void Init() ;
  void Start() ;  // start the timer
  void Stop() ;  // stop the timer
  void *GetLastFocusedWindow() ;
  void SetLastFocusedWindow() ;  // set the focus to the last focused window
  
} ;


#endif // _omUIGrantFocus2User_
