////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#define RESUMEFROMFIRST 30
#define RESUMEFROMTHIS 31
#define RESUMEFROMNEXT 32



// This header contains internal codes for emulation keys


// special keys
#define BACKSPACEKEY 256
#define TABKEY 257
#define CLEARKEY 258
#define ENTERKEY 259
#define SHIFTKEY 260
#define CONTROLKEY 261
#define ALTKEY 262
#define PAUSEKEY 263
#define CAPSLOCKKEY 264
#define ESCKEY 265
#define SPACEKEY 266
#define PAGEUPKEY 267
#define PAGEDOWNKEY 268
#define ENDKEY 269
#define HOMEKEY 270
#define LEFTARROWKEY 271
#define UPARROWKEY 272
#define RIGHTARROWKEY 273
#define DOWNARROWKEY 274
#define SELECTKEY 275
#define PRINTSCREENKEY 276
#define EXECUTEKEY 277
#define SNAPSHOTKEY 278
#define INSKEY 279
#define DELKEY 280
#define HELPKEY 281
#define NUMLOCKKEY 282

// function keys
#define F1KEY 400 
#define F2KEY 401
#define F3KEY 402
#define F4KEY 403
#define F5KEY 404
#define F6KEY 405
#define F7KEY 406
#define F8KEY 407
#define F9KEY 408
#define F10KEY 409
#define F11KEY 410
#define F12KEY 411
#define F13KEY 412
#define F14KEY 413
#define F15KEY 414
#define F16KEY 415


// Use maxmousebuttons +1 because we start indexes from 1
#define MAXMOUSEBUTTONS 4
#define LEFTBUTTON 1
#define CENTRALBUTTON 2
#define RIGHTBUTTON 3


