////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////




#include "joymouseCommandParser.h"

/** Build the class */
joymouseCommandParser::joymouseCommandParser()
{
  // do nothing
}

void joymouseCommandParser::Init()
{
  opts = (joymouseOptions *) wxGetApp().objects.options;

  // build joystick driver object
  joy = new omJoystickDriver(this, 30, wxJOYSTICK1, 0.2, 0.8, 0.8, 0.2, opts->actionOnPress);
  joy->SetMinX(0);
  joy->SetMaxX(255);
  joy->SetMinY(0);
  joy->SetMaxX(255);

  joy->Start();
}


void joymouseCommandParser::Action()
{
  std::cout << "action" << std::endl;
}

void joymouseCommandParser::GoLeft()
{
  std::cout << "go left" << std::endl;
}

void joymouseCommandParser::GoRight()
{
  std::cout << "go right" << std::endl;
}

void joymouseCommandParser::GoUp()
{
  std::cout << "go up" << std::endl;
}

void joymouseCommandParser::GoDown()
{
  std::cout << "go down" << std::endl;
}
