////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include "omARMA.h"


omARMA::omARMA(int Order, std::vector<double> A, std::vector<double> B){

  this->order=Order;
  this->a=A;
  this->b=B;

  for(int i=0; i<=order; i++){
    this->y.insert(y.end(),0);
    this->x.insert(x.end(),0);
  }

}

void omARMA::Initialize(double initValue){
  for(int i=0; i<=order; i++){
    this->x[i]=initValue;
  };

}

double omARMA::Filter(double value){

  for(int i=order; i>0; i--){
    this->y[i]=this->y[i-1];
    this->x[i]=this->x[i-1];
  }

  x[0]=value;

  y[0]=0;
  for(int i=1; i<=order; i++){
    y[0]+=b[i]*x[i]-a[i]*y[i];
  }

  y[0]+=b[0]*x[0];
  y[0]=y[0]/a[0];

  //y[0]=(-a[1]*y[1]-a[2]*y[2]-a[3]*y[3]-a[4]*y[4]-a[5]*y[5]-a[6]*y[6] +b[0]*x[0]+b[1]*x[1]+b[2]*x[2]+b[3]*x[3]+b[4]*x[4]+b[5]*x[5]+b[6]*x[6])/a[0];

  return(y[0]);
}
