////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#include <openmaia/omGetKeyDialog.h>


BEGIN_EVENT_TABLE(omGetKeyDialog, wxDialog)
  EVT_BUTTON(XRCID("button_esc"), omGetKeyDialog::OnEsc)
  EVT_BUTTON(XRCID("button_1"), omGetKeyDialog::On1)
  EVT_BUTTON(XRCID("button_2"), omGetKeyDialog::On2)
  EVT_BUTTON(XRCID("button_3"), omGetKeyDialog::On3)
  EVT_BUTTON(XRCID("button_4"), omGetKeyDialog::On4)
  EVT_BUTTON(XRCID("button_5"), omGetKeyDialog::On5)
  EVT_BUTTON(XRCID("button_6"), omGetKeyDialog::On6)
  EVT_BUTTON(XRCID("button_7"), omGetKeyDialog::On7)
  EVT_BUTTON(XRCID("button_8"), omGetKeyDialog::On8)
  EVT_BUTTON(XRCID("button_9"), omGetKeyDialog::On9)
  EVT_BUTTON(XRCID("button_0"), omGetKeyDialog::On0)
  EVT_BUTTON(XRCID("button_quote"), omGetKeyDialog::OnQuote)
  EVT_BUTTON(XRCID("button_igrave"), omGetKeyDialog::OnIgrave)
  EVT_BUTTON(XRCID("button_bs"), omGetKeyDialog::OnBs)
  EVT_BUTTON(XRCID("button_ins"), omGetKeyDialog::OnIns)
  EVT_BUTTON(XRCID("button_home"), omGetKeyDialog::OnHome)
  EVT_BUTTON(XRCID("button_pgup"), omGetKeyDialog::OnPgUp)
  EVT_BUTTON(XRCID("button_tab"), omGetKeyDialog::OnTab)
  EVT_BUTTON(XRCID("button_q"), omGetKeyDialog::OnQ)
  EVT_BUTTON(XRCID("button_w"), omGetKeyDialog::OnW)
  EVT_BUTTON(XRCID("button_e"), omGetKeyDialog::OnE)
  EVT_BUTTON(XRCID("button_r"), omGetKeyDialog::OnR)
  EVT_BUTTON(XRCID("button_t"), omGetKeyDialog::OnT)
  EVT_BUTTON(XRCID("button_y"), omGetKeyDialog::OnY)
  EVT_BUTTON(XRCID("button_u"), omGetKeyDialog::OnU)
  EVT_BUTTON(XRCID("button_i"), omGetKeyDialog::OnI)
  EVT_BUTTON(XRCID("button_o"), omGetKeyDialog::OnO)
  EVT_BUTTON(XRCID("button_p"), omGetKeyDialog::OnP)
  EVT_BUTTON(XRCID("button_egrave"), omGetKeyDialog::OnEgrave)
  EVT_BUTTON(XRCID("button_plus"), omGetKeyDialog::OnPlus)
  EVT_BUTTON(XRCID("button_ugrave"), omGetKeyDialog::OnUgrave)
  EVT_BUTTON(XRCID("button_canc"), omGetKeyDialog::OnCanc)
  EVT_BUTTON(XRCID("button_end"), omGetKeyDialog::OnEnd)
  EVT_BUTTON(XRCID("button_pgdown"), omGetKeyDialog::OnPgDown)
  EVT_BUTTON(XRCID("button_caps"), omGetKeyDialog::OnCaps)
  EVT_BUTTON(XRCID("button_a"), omGetKeyDialog::OnA)
  EVT_BUTTON(XRCID("button_s"), omGetKeyDialog::OnS)
  EVT_BUTTON(XRCID("button_d"), omGetKeyDialog::OnD)
  EVT_BUTTON(XRCID("button_f"), omGetKeyDialog::OnF)
  EVT_BUTTON(XRCID("button_g"), omGetKeyDialog::OnG)
  EVT_BUTTON(XRCID("button_h"), omGetKeyDialog::OnH)
  EVT_BUTTON(XRCID("button_j"), omGetKeyDialog::OnJ)
  EVT_BUTTON(XRCID("button_k"), omGetKeyDialog::OnK)
  EVT_BUTTON(XRCID("button_l"), omGetKeyDialog::OnL)
  EVT_BUTTON(XRCID("button_ograve"), omGetKeyDialog::OnOgrave)
  EVT_BUTTON(XRCID("button_agrave"), omGetKeyDialog::OnAgrave)
  EVT_BUTTON(XRCID("button_enter"), omGetKeyDialog::OnEnter)
  EVT_BUTTON(XRCID("button_shift"), omGetKeyDialog::OnShift)
  EVT_BUTTON(XRCID("button_minor"), omGetKeyDialog::OnMinor)
  EVT_BUTTON(XRCID("button_z"), omGetKeyDialog::OnZ)
  EVT_BUTTON(XRCID("button_x"), omGetKeyDialog::OnX)
  EVT_BUTTON(XRCID("button_c"), omGetKeyDialog::OnC)
  EVT_BUTTON(XRCID("button_v"), omGetKeyDialog::OnV)
  EVT_BUTTON(XRCID("button_b"), omGetKeyDialog::OnB)
  EVT_BUTTON(XRCID("button_n"), omGetKeyDialog::OnN)
  EVT_BUTTON(XRCID("button_m"), omGetKeyDialog::OnM)
  EVT_BUTTON(XRCID("button_comma"), omGetKeyDialog::OnComma)
  EVT_BUTTON(XRCID("button_dot"), omGetKeyDialog::OnDot)
  EVT_BUTTON(XRCID("button_underscore"), omGetKeyDialog::OnUnderscore)
  EVT_BUTTON(XRCID("button_shift2"), omGetKeyDialog::OnShift2)
  EVT_BUTTON(XRCID("button_up"), omGetKeyDialog::OnUp)
  EVT_BUTTON(XRCID("button_control"), omGetKeyDialog::OnControl)
  EVT_BUTTON(XRCID("button_alt"), omGetKeyDialog::OnAlt)
  EVT_BUTTON(XRCID("button_space"), omGetKeyDialog::OnSpace)
  EVT_BUTTON(XRCID("button_altgr"), omGetKeyDialog::OnAltGr)
  EVT_BUTTON(XRCID("button_sx"), omGetKeyDialog::OnSx)
  EVT_BUTTON(XRCID("button_down"), omGetKeyDialog::OnDown)
  EVT_BUTTON(XRCID("button_dx"), omGetKeyDialog::OnDx)
END_EVENT_TABLE()


/** Build the dialog and load xrc file rapresenting the keyboard to display
    
    @param xrcFile Path of xrc file to load.
*/
omGetKeyDialog::omGetKeyDialog(wxString xrcFile)
{
  // initialize variables
  isKeySelected = false;

  // load xrc file
  wxXmlResource::Get()->InitAllHandlers();  
  wxXmlResource::Get()->Load(xrcFile) ;
  wxXmlResource::Get()->LoadDialog(this, NULL, wxT("omKeyboardDialog"));
 
}

/// Override ShowModal() method of wxDilog
int omGetKeyDialog::ShowModal()
{
  isKeySelected = false;
  return wxDialog::ShowModal();
}


/// Return the code of selected key
wxString omGetKeyDialog::GetSelectedKey()
{
  return selectedKey;
}

/// Return true if the user has selected a key or false otherwhise
bool omGetKeyDialog::IsKeySelected()
{
  return isKeySelected;
}


// keys handlers -----------------

/// key handler
void omGetKeyDialog::OnEsc(wxCommandEvent &event)
{
  selectedKey = _T("esc");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On1(wxCommandEvent &event)
{
  selectedKey = _T("1");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On2(wxCommandEvent &event)
{
  selectedKey = _T("2");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On3(wxCommandEvent &event)
{
  selectedKey = _T("3");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On4(wxCommandEvent &event)
{
  selectedKey = _T("4");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On5(wxCommandEvent &event)
{
  selectedKey = _T("5");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On6(wxCommandEvent &event)
{
  selectedKey = _T("6");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On7(wxCommandEvent &event)
{
  selectedKey = _T("7");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On8(wxCommandEvent &event)
{
  selectedKey = _T("8");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On9(wxCommandEvent &event)
{
  selectedKey = _T("9");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::On0(wxCommandEvent &event)
{
  selectedKey = _T("0");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnQuote(wxCommandEvent &event)
{
  selectedKey = _T("quote");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnIgrave(wxCommandEvent &event)
{
  selectedKey = _T("igrave");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnBs(wxCommandEvent &event)
{
  selectedKey = _T("bs");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnIns(wxCommandEvent &event)
{
  selectedKey = _T("ins");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnHome(wxCommandEvent &event)
{
  selectedKey = _T("home");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnPgUp(wxCommandEvent &event)
{
  selectedKey = _T("pgup");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnTab(wxCommandEvent &event)
{
  selectedKey = _T("tab");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnQ(wxCommandEvent &event)
{
  selectedKey = _T("q");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnW(wxCommandEvent &event)
{
  selectedKey = _T("w");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnE(wxCommandEvent &event)
{
  selectedKey = _T("e");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnR(wxCommandEvent &event)
{
  selectedKey = _T("r");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnT(wxCommandEvent &event)
{
  selectedKey = _T("t");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnY(wxCommandEvent &event)
{
  selectedKey = _T("y");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnU(wxCommandEvent &event)
{
  selectedKey = _T("u");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnI(wxCommandEvent &event)
{
  selectedKey = _T("i");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnO(wxCommandEvent &event)
{
  selectedKey = _T("o");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnP(wxCommandEvent &event)
{
  selectedKey = _T("p");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnEgrave(wxCommandEvent &event)
{
  selectedKey = _T("egrave");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnPlus(wxCommandEvent &event)
{
  selectedKey = _T("plus");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnUgrave(wxCommandEvent &event)
{
  selectedKey = _T("ugrave");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnCanc(wxCommandEvent &event)
{
  selectedKey = _T("canc");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnEnd(wxCommandEvent &event)
{
  selectedKey = _T("end");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnPgDown(wxCommandEvent &event)
{
  selectedKey = _T("pgdown");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnCaps(wxCommandEvent &event)
{
  selectedKey = _T("caps");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnA(wxCommandEvent &event)
{
  selectedKey = _T("a");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnS(wxCommandEvent &event)
{
  selectedKey = _T("s");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnD(wxCommandEvent &event)
{
  selectedKey = _T("d");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnF(wxCommandEvent &event)
{
  selectedKey = _T("f");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnG(wxCommandEvent &event)
{
  selectedKey = _T("g");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnH(wxCommandEvent &event)
{
  selectedKey = _T("h");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnJ(wxCommandEvent &event)
{
  selectedKey = _T("j");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnK(wxCommandEvent &event)
{
  selectedKey = _T("k");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnL(wxCommandEvent &event)
{
  selectedKey = _T("l");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnOgrave(wxCommandEvent &event)
{
  selectedKey = _T("ograve");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnAgrave(wxCommandEvent &event)
{
  selectedKey = _T("agrave");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnEnter(wxCommandEvent &event)
{
  selectedKey = _T("enter");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnShift(wxCommandEvent &event)
{
  selectedKey = _T("shift");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnMinor(wxCommandEvent &event)
{
  selectedKey = _T("minor");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnZ(wxCommandEvent &event)
{
  selectedKey = _T("z");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnX(wxCommandEvent &event)
{
  selectedKey = _T("x");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnC(wxCommandEvent &event)
{
  selectedKey = _T("c");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnV(wxCommandEvent &event)
{
  selectedKey = _T("v");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnB(wxCommandEvent &event)
{
  selectedKey = _T("b");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnN(wxCommandEvent &event)
{
  selectedKey = _T("n");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnM(wxCommandEvent &event)
{
  selectedKey = _T("m");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnComma(wxCommandEvent &event)
{
  selectedKey = _T("comma");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnDot(wxCommandEvent &event)
{
  selectedKey = _T("dot");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnUnderscore(wxCommandEvent &event)
{
  selectedKey = _T("underscore");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnShift2(wxCommandEvent &event)
{
  selectedKey = _T("shift");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnUp(wxCommandEvent &event)
{
  selectedKey = _T("up");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnControl(wxCommandEvent &event)
{
  selectedKey = _T("control");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnAlt(wxCommandEvent &event)
{
  selectedKey = _T("alt");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnSpace(wxCommandEvent &event)
{
  selectedKey = _T("space");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnAltGr(wxCommandEvent &event)
{
  selectedKey = _T("altgr");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnSx(wxCommandEvent &event)
{
  selectedKey = _T("sx");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnDown(wxCommandEvent &event)
{
  selectedKey = _T("down");
  isKeySelected = true;
  this->Close();
}

/// key handler
void omGetKeyDialog::OnDx(wxCommandEvent &event)
{
  selectedKey = _T("dx");
  isKeySelected = true;
  this->Close();
}
