////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include <openmaia/omUIApplication.h>

#include <unistd.h>

///** Sets the path of the application moving to the top of the installation dir  */
// void omUIApplication::SetPath()
// {
//   // get path information from argv[0]
//   // this is different under windows and unix.
//   // In windows the path is absolute, in unix generally is relative

//   std::string op(argv[0]);
  
//   // change the path in unix format always
//   std::string currentPath = MaiaFunctions::GetUnixString(op);
  

//   // path format is something like c:/yourbasepath/bin/application under windows
//   // and ./application or application under unix
//   // find /bin substring to check if use relative or absolute path
//   // I would advice to use absolute path under windows

//   std::string newPath ;
//   int pos = currentPath.find("/bin");
//   if ( pos == -1 )   // substring not found, assume to use relative path 
//     {
//       newPath = ".." ;   // move to the top of the installation
//     }
//   else  // use absolute path
//     {
//       newPath = currentPath.substr(0,pos);
//     }

//   // change to base path
//   chdir(newPath.c_str()) ;
// }


/** Sets the path of the application moving to the top of the installation dir  
    @param profile profile path
*/
void omUIApplication::SetPath(wxString profile)
{
  // change to base path
  wxString binPath(argv[0]) ;
  omFunctions::SetBasePath(binPath) ;
  // change to profile path

  chdir((char *)profile.c_str());
  chdir("maia");

//   wxString dataDir = profile << _T("/maia") ;
//   chdir((char *)dataDir.c_str());
  //system("ls");
}

/** This funcions catch wiindow error handlers like set focus error and show error
 */
void omUIApplication::SetErrorHandlers()
{
  this->SDSetErrorHandlers();
}



