// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include <openmaia/omUIFunctions.h>

/** This functions parses a vector of virtual buttons classes pointer (omUIButton) and
    fills <upper, lower, left and right> of each button to create a bidimensional
    map to navigate buttons with 4 direction kets

    @param buttons vector of buttons to link
*/
void omUIFunctions::Create2DButtonMap(std::vector<omUIButton *> buttons)
{
  //lenght of vector
  int vectorLenght=buttons.size();
  //index to current button
  int currButton;


  //distance value initialized to 0
  float distUpper=0;
  float distLower=0;
  float distLeft=0;
  float distRight=0;

  float currDistance;

  int i;

  //for each button
  for(currButton=0;currButton<vectorLenght;currButton++){

    //distance value initialized to 0
    distUpper=0;
    distLower=0;
    distLeft=0;
    distRight=0;


    //calculate distance with each other button
    for(i=0;i<vectorLenght;i++){

      //button not compared with itself
      if(i!=currButton){
	//Calculate the distance with current button
	currDistance=( (buttons[i])->x - (buttons[currButton])->x)*((buttons[i])->x - (buttons[currButton])->x)+
	  ((buttons[i])->y - (buttons[currButton])->y)*((buttons[i])->y - (buttons[currButton])->y);
	


	//if UPPER
	if(( (buttons[currButton])->y - (buttons[i])->y)>0 ){
	  //if distUpper not setted than distUpper=currDistance
	  if(distUpper==0){
	    distUpper=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->upper=buttons[i];
	  }
	  //if currDistance<distUpper than distUpper=currDistance
	  if(currDistance<distUpper){

	    distUpper=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->upper=buttons[i];
	  }
	}





	//if LOWER
	if( ((buttons[currButton])->y - (buttons[i])->y)<0 ){
	  //if distLower not setted than distLower=currDistance
	  if(distLower==0){
	    distLower=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->lower=buttons[i];
	  }
	  //if currDistance<distUpper than distUpper=currDistance
	  if(currDistance<distLower){
	    distLower=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->lower=buttons[i];
	  }
	}




	//if RIGHT
	if( ((buttons[i])->x - (buttons[currButton])->x)>0 ){
	  //if distRight not setted than distRight=currDistance
	  if(distRight==0){
	    distRight=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->right=buttons[i];
	  }
	  //if currDistance<distRight than distRight=currDistance
	  if(currDistance<distRight){
	    distRight=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->right=buttons[i];
	  }
	}




	//if LEFT
	if( ((buttons[i])->x - (buttons[currButton])->x)<0 ){
	  //if distLeft not setted than distRight=currDistance
	  if(distLeft==0){
	    distLeft=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->left=buttons[i];
	  }
	  //if currDistance<distLeft than distLeft=currDistance
	  if(currDistance<distLeft){ 
	    distLeft=currDistance;
	    //Link current button with 'i' button
	    (buttons[currButton])->left=buttons[i];
	  }
	}



      }//end if

    }//end for

  }//end for


}
