////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include <openmaia/omUIGrantFocus2User.h>

/** Initialize the timer associate with the class
    @param tick tick time of the associated timer in milliseconds
*/
omUIGrantFocus2User::omUIGrantFocus2User(int tick)
{
  tickTime = tick ;
  lastFocusedWindow = NULL ;
  this->SDConstructor() ;
}

/** Initialize the class.
    This function is called after that all objects are istantiated
*/
void omUIGrantFocus2User::Init()
{
}


/** Start the timer */
void omUIGrantFocus2User::Start()
{
  wxTimer::Start(tickTime) ;
}

/** Stop the timer */
void omUIGrantFocus2User::Stop()
{
  wxTimer::Stop() ;
}

/* Get the last non maia focused window.
   The handler must be casted to HWND for Windows or GtkWidget for GTK.
   @return handler of the window or NULL  
*/
void *omUIGrantFocus2User::GetLastFocusedWindow()
{
  return lastFocusedWindow ;
}

/** Set the keyboard focus to the last non maia focused window */
void omUIGrantFocus2User::SetLastFocusedWindow()
{
  // call the system dependent method
  this->SDSetLastFocusedWindow() ;
}


// -------- private methods
void omUIGrantFocus2User::Notify()
{
  // call the system dependent check method
  this->SDCheckFocusedWindow() ;   
}

