////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include <wx/wx.h>

#include <omUIButton.h>

#include <unistd.h>

#define NOMINMAX
#include <windows.h>
#include <wx/msw/winundef.h>




// disable mircrosoft min,max macros that causes troubles :)
//#ifdef min
//#undef min
//#endif

//#ifdef max
//#undef max
//#endif



// in this file is implemented some stuff windows-dipendent :))




// you can find the original implementation of this class in ../common/graphics.cpp
// put the window on top using X11 call to the window manager
// I tried it on kde3
void omUIButton::SDPutOnTop()
{
   this->SetWindowStyleFlag( wxSIMPLE_BORDER | wxSTAY_ON_TOP) ;
   //this->Refresh() ;
   //this->Hide() ;
   //this->Show() ;
}


bool omUIButton::SDIsYourWindow( void *wh)
{
  HWND thisHandler = (HWND) this->GetHandle() ;
  HWND *wwh = (HWND *) wh ;   // passed pointer to handle
  HWND toCheck = *wwh ;   // passed handle

  if ( thisHandler == toCheck)
    return true ;
  else
    return false ;

  

//     GtkWidget *h = (GtkWidget *) this->GetHandle() ;   // get the handle of this window
  
//   Window *wwh = (Window *) wh ;
//   Window toCheck = *wwh ;
//   Window thisHandler = GDK_WINDOW_XWINDOW( h->window) ;

//   if ( thisHandler == toCheck)
//     return true ;
//   else
//     return false ;
}


// play a sound using windows api.
// wave - relative path of the sound to play
// isRelative - true if path is relative to keyboard root
void omUIButton::PlaySoundSD(wxString wave, bool isRelative)
{
  
  wxString currentPath = omFunctions::GetCurrentPath();
  currentPath = omFunctions::GetWindowsString(currentPath);

  wxString toPlay = _T("");
  if (isRelative)
      toPlay << omFunctions::GetWindowsString(wxString(currentPath)) << _T("\\keyboard\\") ;

  toPlay << omFunctions::GetWindowsString(wave);

#ifdef MAIA_DEBUG
  std::cout << "sound to play= " << toPlay << std::endl;
#endif

  //  ::PlaySound( toPlay.c_str(), NULL, SND_ASYNC | SND_FILENAME) ;
}
