// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include <openmaia/omUIGrantFocus2User.h>

#include "omWinData.h"

#include <iostream>


// Implement the windows dependen check the window with focus

// disable mircrosoft min,max macros that causes troubles :)
#define NOMINMAX
#include <windows.h>
#include <wx/msw/winundef.h>

//#ifdef min
//#undef min
//#endif

//#ifdef max
//#undef max
//#endif



void omUIGrantFocus2User::SDConstructor()
{
  // initialize to null the window pointer
  omWinData *data = new omWinData() ;
  data->lastFocusedWindow = 0 ;

  this->sdData = data ;
}


void omUIGrantFocus2User::SDCheckFocusedWindow()
{
  // retrive data
  omWinData *data = (omWinData *) sdData ;

  HWND currFocus = GetForegroundWindow() ;   // call the windows api
  
  // check if passed handler belongs to maia tree

  bool isMaiaWindow = false ;  // by default
  // retrive keyboard pointer from application
  omUIKeyboard *keyboard = (omUIKeyboard *) wxGetApp().objects.keyboard ;
  if ( keyboard != NULL )
    isMaiaWindow = keyboard->IsYourWindow(&currFocus) ;


  if (!isMaiaWindow) 
    {
      // store last focused window
    data->lastFocusedWindow = currFocus ;
    lastFocusedWindow = &(data->lastFocusedWindow) ;
    }
}

// set the focus to the last focused window
void omUIGrantFocus2User::SDSetLastFocusedWindow()
{ 

  // retrive data
  omWinData *data = (omWinData *) sdData ;
  
  if ( data->lastFocusedWindow != 0 ) 
    {
      SetForegroundWindow(data->lastFocusedWindow) ;
    }   
}
