////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

// this is the structure containing system dependent data of MaiaEventCheck class

#ifndef _omX11Data_
#define _omX11Data_

#include <X11/Xlib.h>
#include <X11/Xutil.h>


class omX11Data {
 public:
  // generic data
  Display *display;
  Window rootWindow ;

  // MaiaEventCheck data
  bool actionEcho ;  // semaphor of key echo
  bool upEcho ;  // semaphor of key echo
  bool downEcho ;  // semaphor of key echo
  bool leftEcho ;  // semaphor of key echo
  bool rightEcho ;  // semaphor of key echo

  int actionKeyCode ;   // X11 action key code

  bool actionSemaphore,   // semaphores for keyboard handling
    upSemaphore,
    downSemaphore,
    rightSemaphore,
    leftSemaphore ;

  

} ;



#endif // _omX11Data_
