////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

// this header defines the name of the tags involved in the xml keyboard definition file.

#ifndef _MAIAXMLTAGSHEADER_
#define _MAIAXMLTAGSHEADER_

//  ------------ keyboard tags ----------------------

#define MAIAXMLKEYBOARDTAG _T("keyboard")
#define MAIAXMLKEYBOARDNAME _T("name")
#define MAIAXMLSCREENWIDTH  _T("screen-width")
#define MAIAXMLSCREENHEIGHT  _T("screen-height")
#define MAIAXMLSCANBLOCKTAG  _T("scanblock")
#define MAIAXMLBUTTONTAG  _T("button")
#define MAIAXMLBUTTONNAME  _T("name")
#define MAIAXMLBUTTONPOSITION  _T("position")
#define MAIAXMLBUTTONXPOS  _T("x")
#define MAIAXMLBUTTONYPOS  _T("y")
#define MAIAXMLBUTTONDIMENSION  _T("dimension")
#define MAIAXMLBUTTONHEIGHT  _T("h")
#define MAIAXMLBUTTONWIDTH  _T("w")
#define MAIAXMLBUTTONIMAGETAG  _T("images")
#define MAIAXMLBUTTONNORMALIMAGE  _T("normal")
#define MAIAXMLBUTTONSCANIMAGE  _T("scan")
#define MAIAXMLBUTTONSELIMAGE  _T("selected")
#define MAIAXMLBUTTONSOUNDTAG  _T("sounds")
#define MAIAXMLBUTTONSCANSOUND  _T("scan")
#define MAIAXMLBUTTONSELSOUND  _T("selected")
#define MAIAXMLBUTTONACTIONTAG  _T("action")
#define MAIAXMLBUTTONACTIONAME  _T("name") 
#define MAIAXMLBUTTONACTIONCODE  _T("code")
#define MAIAXMLBUTTONACTIONPARS  _T("pars")
#define MAIAXMLBUTTONBICOTAG  _T("bico")
#define MAIAXMLBUTTONBICOCODE  _T("sequence")


// ------------------------------------ option tags -------------
#define MAIAXMLGENERALOPTIONSTAG  _T("generaloptions")
#define MAIAXMLSCANOPTIONSTAG  _T("scanoptions")
#define MAIAXMLOPTIONTAG  _T("option")
// ---- hardware
#define MAIAXMLSERIALENABLEDTAG  _T("serialenabled")
#define MAIAXMLSERIALPORTTAG  _T("serialport")
#define MAIAXMLKEYBOARDENABLEDTAG  _T("keyboardenabled")
// ---- general
#define MAIAXMLACTIONKEYTAG  _T("actionkey")
#define MAIAXMLUPKEYTAG  _T("upkey")
#define MAIAXMLDOWNKEYTAG  _T("downkey")
#define MAIAXMLLEFTKEYTAG  _T("leftkey")
#define MAIAXMLRIGHTKEYTAG  _T("rightkey")
#define MAIAXML1STKEYBNAME  _T("firstkeyboardname")
#define MAIAXMLAUTOSCANTAG  _T("autoscan")
#define MAIAXMLJOYSTICKTAG  _T("joystick")
#define MAIAXMLDIRECTTAG  _T("direct")
#define MAIAXMLGRABKEYSTAG  _T("grabkeys")
#define MAIAXMLONPRESSTAG  _T("actiononpress")
#define MAIAXMLENABLESOUNDTAG  _T("enablesound")
// ---- scan 
#define MAIAXMLSCANTIME  _T("scantime")
#define MAIAXMLSCANLOOPSTAG  _T("scanloopsnumber")
#define MAIAXMLSCANRESUMEFROMTAG  _T("scanresumefrom")
#define MAIAXMLDELAYAFTERCLICKTAG  _T("delayafterclick")
#define MAIAXMLEXITBLOCKAFTERCLICK  _T("exitblockafterclick")
#define MAIAXMLDELAYAFTERACTION  _T("delayafteraction")
#define MAIAXMLDELAYAFTERENDBLOCK  _T("delayafterendblock")


// -- various
#define MAIAXMLTHISVALUE  _T("this")
#define MAIAXMLFIRSTVALUE  _T("first")
#define MAIAXMLNEXTVALUE  _T("next")




#endif // _MAIAXMLTAGSHEADER_

