////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#ifndef _maiaconfigMain_
#define _maiaconfigMain_

#include <wx/wx.h>
#include <wx/image.h>
#include <wx/cmdline.h>
#include <wx/xrc/xmlres.h>

#include <openmaia/libopenmaia.h>

#include "maiaconfigFrame.h"




/** @ingroup maiaconfig

This is the main class of the maiaconfig application.<br>
maiaconfig application is used to control options of the maia application. 
Options are handled with a frame and options are syncronized with maia application via TCP messages using 
the openmaia server.

*/

class maiaconfigMain : public wxApp
{
public:
  bool inDeveloperTree;

  wxString host, profile ;
  int port;
  
  
  wxString binPath;  ///< Path of this binary file

  bool OnInit();
  int OnExit();
  virtual void OnInitCmdLine(wxCmdLineParser&);
  virtual bool OnCmdLineError(wxCmdLineParser&);
  virtual bool OnCmdLineHelp(wxCmdLineParser&);
  virtual bool OnCmdLineParsed(wxCmdLineParser&);

  /* private: */
  /*   wxCmdLineParser *parser; */
};

DECLARE_APP(maiaconfigMain) 

#endif  //_maiaconfig_
