////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
    #pragma implementation "maiasms.cpp"
#endif

// For compilers that support precompilation
#include "wx/wxprec.h"

// Include private headers
#include "maiasms.h"

//------------------------------------------------------------------------------
// constants
//------------------------------------------------------------------------------
IMPLEMENT_APP(maiasmsMain)

BEGIN_EVENT_TABLE(maiasmsMain, wxApp)
END_EVENT_TABLE()

// bool maiasmsMain::OnInit() 
// {
//   return FALSE;
// }

/// Main function of the wx application
//int main(int argc, char **argv)
bool maiasmsMain::OnInit() 
{
  wxString port;	///<Cellular device
  omSmsManager	*smsmanager;



  smsmanager=new omSmsManager();

  port=wxString(argv[1]);
  if(port.IsEmpty())
    {
      std::cout<<"Usage: maiasms <device>"<<std::endl;
      std::cout<<"  <device> = /dev/ircomm0 for IrDA device"<<std::endl;
      std::cout<<"  <device> = /dev/ttyS0 for serial device"<<std::endl;

      port=smsmanager->AutoDetect(); //Try autodetecting device;

      if(port.IsEmpty()) exit(0);

    }
std::cout<<"###"<<port<<std::endl;
  std::cout<<"Process start..."<<std::endl;
  maiasmsSmtp *smtp=new maiasmsSmtp(smsmanager,port);
  maiasmsPop *pop=new maiasmsPop(smsmanager,port);

  return(true);
}
