////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

/** @defgroup maiasms MAIA SMS */

#ifndef __maiasms_h__
#define __maiasms_h__

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "maiasms.cpp"
#endif

// Include wxWindows' headers

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <openmaia/libopenmaia.h>
#include "maiasmsPop.h"
#include "maiasmsSmtp.h"




//----------------------------------------------------------------------------
// maiasms
//----------------------------------------------------------------------------
/** 
    @ingroup maiasms

    This class implements a server ...
*/




class maiasmsMain: public wxApp
{
 public:
  virtual bool OnInit();
  
  DECLARE_EVENT_TABLE()

 private:
  wxString port;	///<Cellular device
  omSmsManager	*smsmanager;
} ;

DECLARE_APP(maiasmsMain)





#endif
