////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#ifndef _maiasmsPop_
#define _maiasmsPop_

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <openmaia/libopenmaia.h>
#include <wx/socket.h>

/** 
    @ingroup maiasms

    This class implements a POP emulator for SMS messages.
*/

#define POP_PORT 110

class maiasmsPop: public wxEvtHandler
{
 public:
  maiasmsPop(omSmsManager *smsmanagerConstructor, wxString deviceConstructor);
  
  DECLARE_EVENT_TABLE()

 private:
  wxSocketServer *server ;

  wxString device;
  omSmsManager	*smsmanager; ///<Phone Manager object
  omSmsArray *smsarray;		///<Dynamic array of SM
  wxArrayString *mailarray;	///<Dynamic array of mail translation of SM

  int status;	///<POP status
  wxString text; ///<Text received by socket

  wxString username;	///<Sender address
  wxString password;	///<Destination address

  void OnServerEvent(wxSocketEvent &);
  void OnSocketEvent(wxSocketEvent &);

  void CreateMail();	///<Create a Mail array from SMS array
  int mailID;

};


#endif
