////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
    #pragma implementation "maiasmsedit.cpp"
#endif

// For compilers that support precompilation
#include "wx/wxprec.h"

#include "wx/filename.h"
#include "wx/config.h"

// Include private headers
#include "maiasmsedit.h"

IMPLEMENT_APP(maiasmseditMain)

//------------------------------------------------------------------------------
// constants
//------------------------------------------------------------------------------

#define HISTORY_ENTRIES 3


// ============================================================================
// implementation
// ============================================================================




// The `main program' equivalent, creating the windows and returning the
// main frame
bool maiasmseditMain::OnInit()
{
  //Initializing resource paths
  binPath=wxString(argv[0]);
  userDataPath=omFunctions::GetUserDataPath(binPath);
  sharedPath=omFunctions::GetSharedPath(binPath);

    // Create the main frame window
    maiasmseditFrame* frame = new maiasmseditFrame((wxFrame *) NULL, -1,
                                 _T("MAIA SMS Manager"),
                                 wxPoint(100, 100), wxSize(600, 400));

    frame->Show(TRUE);

    SetTopWindow(frame);







/********* Example of usage of MaiaSmsManager library **************

//SERIAL
  if(event.GetInt()==0){
    if(smsmanager->InitDevice(_T("/dev/ttyS0"))==0){
      std::cout<<"Error to initialize the device!"<< std::endl;
    }
  }
//IrDA
  if(event.GetInt()==1){
    if(smsmanager->InitDevice(_T("/dev/ircomm0"))==0){
      std::cout<<"Error to initialize the device!"<< std::endl;
    }
  }

    smsmanager=new omSmsManager();
    if(smsmanager->InitDevice(_T("/dev/ircomm0"))==0){
      //if(smsmanager->InitDevice(_T("/dev/ttyS0"))==0){
      std::cout<<"Error to initialize the device!"<< std::endl;
      exit(1);
    }


    //smsmanager->SendSMS(_T("3356892090"),_T("MaiaSms: Altro messaggio abbastanza lungo con un p di caratteri strani: ' @ # ciao."));

omSms ml[MAX_MESSAGES_DOWNLOAD];
int n=0;
    if((n=smsmanager->ReceiveMessages(ml))==0){
      std::cout<<"Error to receive message!"<< std::endl;
      exit(1);
    }

      std::cout<<n<< std::endl;
*/


    return TRUE;
}



