////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////

#include "openmaiaConnectedAgent.h"

openmaiaConnectedAgent::openmaiaConnectedAgent(openmaiaServer *tn, wxSocketBase *s)
{
  toNotify = tn ;
  sock = s ;    
  
  // initialize default values
  agentRegistered=false;
  agentName=_T("");
  serviceName=_T("");

  // find socket informations
  wxIPV4address addr;
  sock->GetPeer(addr);
  host = addr.Hostname();
  port = addr.Service();
}

openmaiaConnectedAgent::~openmaiaConnectedAgent()
{
  sock->Close();
  sock->Destroy();
}

void openmaiaConnectedAgent::SendMessage(omTCPMessage m)
{
  wxString formattedMessage = m.GetFormattedMessage();
  // write message to the socket
  sock->Write(formattedMessage.c_str(), formattedMessage.Length());



//   wxString formattedMessage ;
//   formattedMessage.Printf("%s%s%s%s%s%s\n",MAIACOMMAND,
// 			  m.GetCommand().c_str(), MAIASEPARATOR,
// 			  MAIAPARAMETERS, m.GetParameters().c_str(),MAIAENDMESSAGE);
//   sock->Write(formattedMessage.c_str(), formattedMessage.Length());
}

/** Analize a char coming from TCP/IP connection.
    @param c char to analize
*/
void openmaiaConnectedAgent::AnalizeChar(char c)
{
  int retValue = tcpParser.AnalizeChar(c);
  if (retValue != OM_NO_MESSAGE)   // message received
    {
      if (OM_REGISTER_MESSAGE)
	{
	  agentRegistered=true;
	  tcpParser.GetRegisterMessage(&agentName, &serviceName);
	}

      if (OM_GENERIC_MESSAGE)
	{
	  /// @todo Implement message destination handling
	  omTCPMessage mess;
	  tcpParser.GetGenericMessage(&mess);
	  // send message to openmaia main
	  toNotify->AgentMessage(host, port, mess);
	}
    }
}
