////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


// this class stores network informations about generi openmaiaConnectedAgent

#ifndef _openmaiaConnectedAgent_
#define _openmaiaConnectedAgent_

class openmaiaServer;

#include <iostream>
#include <string>

#include <wx/wx.h>
#include <wx/socket.h>

#include <openmaia/libopenmaia.h>
#include "openmaiaServer.h"


class openmaiaConnectedAgent
{
 private:
  wxSocketBase *sock;           ///< socket information

  openmaiaServer *toNotify ;   ///< object to notify
  wxString host; 	 	///< agent hostname
  int port;			///< agent service

  // registration information  
  bool agentRegistered;         ///< flag
  wxString agentName;           ///< buffer
  wxString serviceName;		///< buffer

  omTCPParser tcpParser;	///< TCP parser object

 public:
  openmaiaConnectedAgent(openmaiaServer *, wxSocketBase *);
  ~openmaiaConnectedAgent();
  void SendMessage(omTCPMessage);   // send a message to the agent

  void AnalizeChar(char);             // send a char stored 
  
  
};

#endif  // _openmaiaConnectedAgent_
