////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
///////////////////////////////////////////////////////////////////////////////


#ifndef _openmaiaProcess_
#define _openmaiaProcess_

#include <wx/wx.h>
#include <wx/process.h>
#include <wx/txtstrm.h>

// class prototipes
class openmaiaProcessesHandler;

#include "openmaia.h"
#include "openmaiaProcessesHandler.h"


/** @ingroup openmaia
    openmaia child process handler.

    This class is used to handle a child process lounched from openmaia.
    The class is derived from wxProcess class and handle process events such as streams flush and
    process termination.
    When a process terminate a NotifyProcessStop is generated and sent to the application 
    processesHandler class.
*/

class openmaiaProcess: public wxProcess
{
 private:
  openmaiaProcessesHandler *toNotify;   ///< Pointer to class that will receive events

 public:
  openmaiaProcess(openmaiaProcessesHandler *) ;
  virtual void OnTerminate(int, int) ;
  void FlushStream() ;
} ;



#endif  // _openmaiaProcess_
