////////////////////////////////////////////////////////////////////////////////
// This code is part of the MaiaProject free software
//
// Keyboard and Mouse Emulator - Virtual keyboard Engine
//
// Copyright (c) 2002-2003 Luca Clivio <luca.clivio@maiaproject.org>
// Tel. +39-347-2538040
// via B.Croce 2, 20037 Paderno Dugnano (Milano) - Italy
//
// Developers:
//    Simone Mangano <simone.mangano@maiaproject.org>
//    Andrea Tosato  <andrea.tosato@maiaproject.org>
//
//  -----------------------------------------------------------------------------
//  This program is free software; This program is free software; 
//  you can redistribute it and/or modify it under the terms of the 
//  GNU General Public License as published by the Free Software Foundation; 
//  either version 2 of the License, or	(at your option) any later version.
//  but WITHOUT ANY WARRANTY; without even the implied warranty of				
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the				
//  GNU General Public License for more details.						
//  You should have received a copy of the GNU General Public License				
//  along with this program; if not, write to the Free Software					
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.					
////////////////////////////////////////////////////////////////////////////////


#ifndef _openmaiaServer_
#define _openmaiaServer_

class openmaiaConnectedAgent;


#include "openmaiaConstants.h"
#include "openmaiaConnectedAgent.h"


#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>

#include <wx/wx.h>
#include <wx/socket.h>
#include <wx/hashmap.h>

#include <openmaia/libopenmaia.h>

#include <vector>

/** 
    @ingroup openmaia

    This class implements a server ...
*/


class openmaiaServer: public wxEvtHandler
{
 public:
  openmaiaServer();
  void AgentMessage(wxString, int, omTCPMessage) ;

  DECLARE_EVENT_TABLE()

 private:
  int nagents ;
  wxSocketServer *server ;
  
  std::vector<wxString> agentKeys;
  WX_DECLARE_STRING_HASH_MAP(openmaiaConnectedAgent*, SocketMap);
  SocketMap agentsMap;

  void OnServerEvent(wxSocketEvent &);
  void OnSocketEvent(wxSocketEvent &);
  

  
  
} ;


#endif  // _openmaiaServer_
